import { LitElement, nothing } from "lit";
import { customElement, property, state } from "lit/decorators.js";
import { dispatchNumberFormatEvent } from "../../common/formats/format-common.js";
import "../../common/atomic-component-error/atomic-component-error.js";
import { errorGuard } from "../../../decorators/error-guard.js";
function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : null === desc ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if ("object" == typeof Reflect && "function" == typeof Reflect.metadata) return Reflect.metadata(k, v);
}
class AtomicFormatUnit extends LitElement {
    connectedCallback() {
        super.connectedCallback();
        dispatchNumberFormatEvent((value, languages)=>this.format(value, languages), this).catch((error)=>{
            this.error = error;
        });
    }
    render() {
        return nothing;
    }
    constructor(...args){
        super(...args), this.unitDisplay = 'short', this.format = (value, languages)=>value.toLocaleString(languages, {
                style: 'unit',
                unit: this.unit,
                unitDisplay: this.unitDisplay
            });
    }
}
_ts_decorate([
    property({
        reflect: true
    }),
    _ts_metadata("design:type", String)
], AtomicFormatUnit.prototype, "unit", void 0);
_ts_decorate([
    property({
        reflect: true,
        attribute: 'unit-display'
    }),
    _ts_metadata("design:type", String)
], AtomicFormatUnit.prototype, "unitDisplay", void 0);
_ts_decorate([
    state(),
    _ts_metadata("design:type", "u" < typeof Error ? Object : Error)
], AtomicFormatUnit.prototype, "error", void 0);
_ts_decorate([
    errorGuard(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", []),
    _ts_metadata("design:returntype", void 0)
], AtomicFormatUnit.prototype, "render", null);
AtomicFormatUnit = _ts_decorate([
    customElement('atomic-format-unit')
], AtomicFormatUnit);
export { AtomicFormatUnit };
